package ueb072pixelbild;

import processing.core.*;

@SuppressWarnings("serial")
public class Ueb072PixelBild extends PApplet {

	PImage original;
	PImage bearbeitet;

	int BORDER = 10;
	int sumPixel = 1; // Anzahl Pixel zusammenfassen

	public void setup() {
		// original = loadImage("lincoln.png");
		original = loadImage("sonnenblume.jpg");

		updateImage();

		size(BORDER + original.width + BORDER + bearbeitet.width + BORDER,
				BORDER + original.height + BORDER);
	}

	public void draw() {
		background(255, 255, 255);
		image(original, BORDER, BORDER, original.width, original.height);
		image(bearbeitet, BORDER + original.width + BORDER, BORDER,
				bearbeitet.width, bearbeitet.height);
	}

	public void mouseMoved() {
		sumPixel = (int) (255.0 / (displayWidth) * mouseX) + 1;
		updateImage();
	}

	public void updateImage() {
		bearbeitet = new PImage(original.width, original.height);
		bearbeitet.loadPixels();

		for (int bearbeitetY = 0; bearbeitetY < original.height / sumPixel; bearbeitetY++) {
			for (int bearbeitetX = 0; bearbeitetX < original.width / sumPixel; bearbeitetX++) {
				int originalX = bearbeitetX * sumPixel;
				int originalY = bearbeitetY * sumPixel;
				int originalFarbe = getColor(original, sumPixel, originalX,
						originalY);

				setNewColor(bearbeitet, sumPixel, bearbeitetX * sumPixel,
						bearbeitetY * sumPixel, originalFarbe);
			}
		}
		bearbeitet.updatePixels();
	}

	public int getColor(PImage image, int sumPixel, int xPos, int yPos) {
		int orgColor = 0;
		float r = 0;
		float g = 0;
		float b = 0;
		for (int y = 0; y < sumPixel; y++) {
			for (int x = 0; x < sumPixel; x++) {
				orgColor = image.pixels[(yPos + y) * image.width + (xPos + x)];
				r += orgColor >> 16 & 0xFF; // red(orgColor);
				g += orgColor >> 8 & 0xFF; // green(orgColor);
				b += orgColor & 0xFF; // blue(orgColor);
			}
		}
		return color(r / (sumPixel * sumPixel), g / (sumPixel * sumPixel), b
				/ (sumPixel * sumPixel));
	}

	public void setNewColor(PImage image, int sumPixel, int xPos, int yPos,
			int newColor) {
		for (int y = 0; y < sumPixel; y++) {
			for (int x = 0; x < sumPixel; x++) {
				image.pixels[(yPos + y) * image.width + xPos + x] = newColor;
			}
		}
	}
}
